function [ fsmean, fsvar]=test_GPR_MTL(x,X,alpha,L,hyper_x,t,t_pointer,Kt,DataCov)
% PP     : row vector of posterior class probabilities 
% fs_var : row vector of variances of the latents.
[dim,m] =  size(x);
fsmean  = zeros(m,length(Kt));
fsvar   = zeros(m,length(Kt));
for k=1:m
    a  =  x(:,k);
    kx     =  feval(DataCov,a,X,hyper_x);
    kstar  =  feval(DataCov,a,a,hyper_x);
    Km     =  sparGPMTL(Kt,kx,t,t_pointer);
    Kmstar =  sparGPMTL(Kt,kstar,t,t_pointer);
    fsmean(k,:)  =  Km'*alpha;
    for i = 1:length(Kmstar)    
        ni  =  L'\Km(:,i);
        fsvar(k,i) = Kmstar(i)-ni'*ni;    
    end
    
end

