function [PD_E]=Grad_GPR_STL(hyper,X,Y,DataCov,Sdist)
% function that computes  the gradients with
% respect to data and task hyperparameters, to be used  with scg.m.
hyper   = hyper';

[dim,N] = size(X);   % number of data points in all tasks
noise   = 1e-9;      % Set noise for data covariance function

% Set number of hyperparameters for the data and task covariance function
% Set functions for gradients

if strcmp(DataCov,'covar_SE_exp');
    DataCov_d = 'covar_SE_exp_dv';
    dx = 2;
end
if strcmp(DataCov,'covar_Lin');
    DataCov_d = 'covar_Lin_dv';
    dx = 1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hyper_x  =  hyper(1:dx);
hyper_n  =  exp(hyper(dx+1));

K = (feval(DataCov,X,X,hyper_x,Sdist)+noise*eye(N))+hyper_n*eye(N);
L = chol(K); 
% a      = L'\(L\Y);
a = solve_chol(L,Y);
invK = inv(K);

%%%%%%%Gradients for data Covariance hyperparameters
for i=1:length(hyper_x)
    kxd = feval(DataCov_d,X,X,hyper_x,Sdist,i);         
    Gradx(i)=-0.5*(trace((a*a' - invK)*kxd));
end
%%%%%%%Gradients for noise hyperparameter
kxn   = hyper_n*eye(N);
Gradn = -0.5*(trace((a*a' - invK)*kxn));
PD_E=[Gradx';Gradn';]';
% if strcmp(DataCov,'covar_Lin_noH');
% PD_E=[Gradx';Gradn';]';
% else
% PD_E=Gradn';
% end
