function [logZep]=MargL_GPR_STL(hyper,X,Y,DataCov,Sdist)
% function that computes the log-marginal likelihood given data and task 
% hyperparameters, to be used with scg.m.
hyper    = hyper';
[dim,N]  = size(X); % number of data points in all tasks
noise    = 1e-9;      % Set noise for data covariance function
% Set number of hyperparameters for the data covariance function
if strcmp(DataCov,'covar_SE_exp');
    dx=2;
end
if strcmp(DataCov,'covar_Lin')
    dx=1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hyper_x  =  hyper(1:dx);
hyper_n  =  exp(hyper(dx+1));


KGS = (feval(DataCov,X,X,hyper_x,Sdist)+noise*eye(N))+hyper_n*eye(N);
L   = chol(KGS); 

a = solve_chol(L,Y);

logZep = -0.5*Y'*a -sum(log(diag(L)))-0.5*N*log(2*pi);

logZep = -logZep;
    
