function [ fsmean, fsvar]=test_GPR_STL(x,X,alpha,L,hyper_x,DataCov)
% function to compute posterior class probabilities  for class "+1" 
% for each of the tasks, as well as the variance of the test latent function.
% PP     : row vector of posterior class probabilities 
% fs_var : row vector of variances of the latents.

[dim,m] = size(x);
fsmean  = zeros(m,1);
fsvar   = zeros(m,1);
for k=1:m
    a  =  x(:,k);
    kx    =  feval(DataCov,a,X,hyper_x);
    kstar =  feval(DataCov,a,a,hyper_x)+1e-9;
    ni    =  L'\kx;
    fsmean(k)  = kx'*alpha;
    fsvar(k)   = kstar-ni'*ni;
end

