function [y,L]=covar_Td_cor0(x,hyper,cor1,dum)
% Correllation task covariance matrix, with values ranging from 0-1. Task 
%

m=length(x);
L=zeros(m,m);
H=reshape(hyper,m,m-1);

dummy=0;

for j=1:m-1
    for i=1:m
        dummy=dummy+1;
        if dummy==cor1
            rd=i;
            cd=j;
            break
        end
    end
end


for i=rd:rd
    for j=cd:m
        g=1;
        for k=1:j-1
            if k~=cd 
                g=g*sin((pi/2)*(1+exp(-H(i,k)))^(-1)); 
            end
            if k==cd
                g=g*(pi/2)*(exp(-H(rd,cd))/((1+exp(-H(rd,cd)))^2))...
                    *cos((pi/2)*(1+exp(-H(rd,cd))).^(-1));
                
            end
        end
        
        if j~=m && j==cd
            L(i,j)=-(pi/2)*(exp(-H(i,j))/((1+exp(-H(i,j)))^2))...
                *sin((pi/2)*(1+exp(-H(i,j))).^(-1))*g;
            
        end
        if j~=m && j~=cd
            L(i,j)=cos((pi/2)*(1+exp(-H(i,j))).^(-1))*g;
        end
        
        if j==m
            L(i,j)=g;
        end     
        
    end
end



y=L*L';
